<?php

require "aps/2/runtime.php";

/**
 * Class cloud presents application and its global parameters
 * @type("http://aps-standard.org/samples/vrd/cloud/1.0")
 * @implements("http://aps-standard.org/types/core/application/1.0","http://odin.com/init-wizard/config/1.0","http://odin.com/aps/types/oa/vendor-contract/1.0")
 */
class cloud extends APS\ResourceBase
{
    # Link to collection of contexts. Pay attention to [] brackets at the end of the @link line.
    /**
     * @link("http://aps-standard.org/samples/vrd/context/1.0[]")
     */
    public $contexts;

    # Demonstration of global connection settings that will be configured by the provider.
    # They must be forwarded to the app endpoint to set the connection with the external cloud system.
    /**
     * @type(string)
     * @title("Application Host")
     * @description("Cloud management server IP or domain name")
     */
    public $apphost="aps.test";

    /**
     * @type(string)
     * @title("Cloud Admin")
     * @description("Cloud administrator")
     */
    public $cloudadmin="admin";

    /**
     * @type(string)
     * @title("Cloud Password")
     * @description("Cloud administrator password")
     * @encrypted
     */
    public $cloudpass;

    # This is the property implemented from the VendorContract APS type. Added here for testing purposes only:
    public $vendorContract;

    public function provision() {
        $deletedDir = "deleted";
        if (!file_exists($deletedDir))
        {
            mkdir($deletedDir);
        }

        # For testing purposes only - default value:
        $this->vendorContract = "1234-5678";
    }

    public function getInitWizardConfig()
    {
        $myfile = fopen("./wizard_data.json", "r") or die("Unable to open file!");
        $data = fread($myfile,filesize("./wizard_data.json"));
        fclose($myfile);
        return json_decode($data);
    }

    public function testConnection()
    {
        return "";
    }

    public function validateInitWizardData()
    {
        return "";
    }

}
